;================================================================================
clip_triangles:
; clipping triangles not beeing in teslate area
   push  ebp
   mov   ebp,esp
   sub   esp,12
   .tri_ptr equ dword[ebp-4]
   .cntt     equ dword[ebp-8]

   mov     eax,[triangles_count_var]
   imul    eax,[i12]
   add     eax,20
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_ptr,eax

   mov     edi,eax
   mov     esi,[triangles_ptr]
   mov     ecx,[triangles_count_var]
   mov    .cntt,0
  .l:
   mov     eax,[esi]
   mov     ebx,[esi+4]
   mov     edx,[esi+8]
   imul    eax,[i12]
   imul    ebx,[i12]
   imul    edx,[i12]
   add     eax,[points_rotated_ptr]
   add     ebx,[points_rotated_ptr]
   add     edx,[points_rotated_ptr]
   movlps  xmm0,[eax]
   movlps  xmm1,[ebx]
   movlps  xmm2,[edx]
   movlhps xmm0,xmm0
   movlhps xmm1,xmm1
   movlhps xmm2,xmm2
   cmpltps xmm0,[tri_area_x1]
   cmpltps xmm1,[tri_area_x1]
   cmpltps xmm2,[tri_area_x1]
   movhlps xmm3,xmm0
   movhlps xmm4,xmm1
   movhlps xmm5,xmm2
   xorps   xmm0,xmm3
   xorps   xmm1,xmm4
   xorps   xmm2,xmm5
   pand    xmm0,xmm1
   pand    xmm0,xmm2
   movmskps eax,xmm0
   and     eax,11b
   cmp     eax,11b
   jne     @f
   movups  xmm0,[esi]
   movups  [edi],xmm0
   add     edi,12
   inc     .cntt
  @@:
   add     esi,12
   dec     ecx
   jnz     .l

   mov     ecx,.cntt
   cmp     ecx,[triangles_count_var]
   je      @f
   mov     [triangles_count_var],ecx
   invoke  VirtualFree,[triangles_ptr],0,MEM_RELEASE
   push    .tri_ptr
   pop     [triangles_ptr]
   jmp     .end
  @@:
   invoke  VirtualFree,.tri_ptr,0,MEM_RELEASE

 .end:

   mov    esp,ebp
   pop    ebp
ret
;======================================================================
rm_inner_faces:

   push    ebp
   mov     ebp,esp
   sub     esp,8

   .trii_count equ dword[ebp-4]
   .trii       equ dword[ebp-8]

   xor     ebx,ebx
  .alloc:
    mov     eax,1050*1050*4+65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx],eax

   mov      eax,1050*1050*4+65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx+4],eax

   mov      eax,[triangles_count_var]
   add      eax,65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx+8],eax


   mov      eax,[points_count_var]
   imul     eax,[i12]
   add      eax,30
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx+12],eax


   add      ebx,16
   cmp      ebx,16*4
   jne     .alloc


   if 1
     invoke CreateThread,NULL,NULL,th_inner_fc0,\
            NULL,NORMAL_PRIORITY_CLASS,\
            [ThreadID0]
     mov    [hthread0],eax
     invoke SetThreadPriority,hthread0,THREAD_PRIORITY_TIME_CRITICAL

     invoke CreateThread,NULL,NULL,th_inner_fc1,\
            NULL,NORMAL_PRIORITY_CLASS,\
            [ThreadID1]
     mov    [hthread1],eax
     invoke SetThreadPriority,hthread1,THREAD_PRIORITY_TIME_CRITICAL

     invoke CreateThread,NULL,NULL,th_inner_fc2,\
            NULL,NORMAL_PRIORITY_CLASS,\
            [ThreadID2]
     mov    [hthread2],eax
     invoke SetThreadPriority,hthread2,THREAD_PRIORITY_TIME_CRITICAL

     invoke CreateThread,NULL,NULL,th_inner_fc3,\
            NULL,NORMAL_PRIORITY_CLASS,\
            [ThreadID3]
     mov    [hthread3],eax
     invoke SetThreadPriority,hthread3,THREAD_PRIORITY_TIME_CRITICAL

     invoke SetThreadAffinityMask,[hthread0],0 ;1
     invoke SetThreadAffinityMask,[hthread1],0 ;2
     invoke SetThreadAffinityMask,[hthread2],0 ;3
     invoke SetThreadAffinityMask,[hthread3],0 ;4

     invoke ResumeThread,[hthread0]
     invoke ResumeThread,[hthread1]
     invoke ResumeThread,[hthread2]
     invoke ResumeThread,[hthread3]

     invoke WaitForMultipleObjectsEx,4,hthread0,1,-1,0

     invoke CloseHandle,[hthread0]
     invoke CloseHandle,[hthread1]
     invoke CloseHandle,[hthread2]
     invoke CloseHandle,[hthread3]
   end if

;   call th_inner_fc0
;   call th_inner_fc1
;   call th_inner_fc2
;   call th_inner_fc3



   mov    ebx,16      ; merge visable triangles list
  .nx_tri_p:          ; next tri list params
   mov    edi,[thread_params+8]
   mov    esi,[thread_params+8+ebx]
   mov    ecx,[triangles_count_var]
  .mv:
   cmp    byte[esi],1
   jne    @f
   mov    al,[esi]
   mov    [edi],al
  @@:
   inc    esi
   inc    edi
   loop   .mv
   add    ebx,16
   cmp    ebx,64
   jne    .nx_tri_p

   mov    esi,[thread_params+8]    ; count visable tris
   mov    ecx,[triangles_count_var]
   xor    ebx,ebx
  .cnt:
   cmp    byte[esi],1
   jne    @f
   inc    ebx
  @@:
   inc    esi
   loop   .cnt
   mov    .trii_count,ebx
   imul   ebx,[i12]
   add    ebx,1024


   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .trii,eax

   mov    ebx,[thread_params+8] ; renew triangles list
   mov    esi,[triangles_ptr]
   mov    edi,.trii
   mov    ecx,[triangles_count_var]
 .move:
   cmp    byte[ebx],1
   jne    @f
   movdqu xmm0,[esi]
   movq   [edi],xmm0
   psrldq xmm0,8
   movd   [edi+8],xmm0
   add    edi,12
  @@:
   add    esi,12
   inc    ebx
   loop   .move

   invoke VirtualFree ,[triangles_ptr] ,0 , MEM_RELEASE
   push   .trii
   pop    [triangles_ptr]
   push   .trii_count
   pop    [triangles_count_var]

  xor     ebx,ebx
 @@:
  invoke  VirtualFree,[thread_params+ebx],0,MEM_RELEASE
  add     ebx,4
  cmp     ebx,64
  jne     @b

   cls
   mov   esp,ebp
   pop   ebp
ret

th_inner_fc0:
  xor   eax,eax
  call  rm_inner_faces_th
ret
th_inner_fc1:
  mov   eax,1
  call  rm_inner_faces_th
ret
th_inner_fc2:
  mov   eax,2
  call  rm_inner_faces_th
ret
th_inner_fc3:
  mov   eax,3
  call  rm_inner_faces_th
ret

;======================================================================
rm_inner_faces_th:
;  Remove inner faces.
;  Maybye in the future I perform removing faces that have
;  degenerated vertices also.
; in:
;  eax = -1 -> leave only front, otherwise ->
;   -> eax = thread No
;  edi -> vertices to project
;  in threaded cause :
;   dword[thread_params]    -  .z_buff     - zbuffer
;   dword[thread_params+4]  -  .prj_buff   - project buffer
;   dword[thread_params+8]  -  .tri_buff   - triangles buffer
;   dword[thread_params+12] -  .points_rot - vertices rotated buffer

   push  ebp
   mov   ebp,esp
   sub   esp,136

   .z_buff     equ dword[ebp-4]
   .prj_buff   equ dword[ebp-8]
   .tri_buff   equ dword[ebp-12]
   .side0      equ dword[ebp-16]
   .tri_count  equ dword[ebp-20]
   .tri        equ dword[ebp-24]
   .sinx       equ dword[ebp-28]
   .cosx       equ dword[ebp-32]
   .siny       equ dword[ebp-36]
   .cosy       equ dword[ebp-40]
   .sinz       equ dword[ebp-44]
   .cosz       equ dword[ebp-48]
   .points_rot equ dword[ebp-52]
   .side1      equ dword[ebp-56]
   .side2      equ dword[ebp-60]
   .matrix     equ [ebp-96]
   .tri_buffe  equ [ebp-100]
   .only_front equ dword[ebp-104]
   .vert_to_prj equ dword[ebp-108]
   .start0     equ dword[ebp-112]
   .start1     equ dword[ebp-116]
   .start2     equ dword[ebp-120]
   .end0       equ dword[ebp-124]
   .end1       equ dword[ebp-128]
   .end2       equ dword[ebp-132]
   .step       equ dword[ebp-136]


   mov     .only_front,eax      ; th_no
   mov     .vert_to_prj,edi

   prompt  prompt_inside_fac

   cmp     eax,-1
   jne     .no_crop_front
   mov     ebx,-17
   mov     .start0,ebx
   mov     .start1,ebx
   mov     .start2,ebx
   mov     ebx,17
   mov     .end0,ebx
   mov     .end1,ebx
   mov     .end2,ebx
   mov     .step,16
; Alloc 1000x1000  buffs
   mov     eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .z_buff,eax

   mov     eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .prj_buff,eax

   mov     eax,[triangles_count_var]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_buff,eax


   mov     eax,[points_count_var]
   imul    eax,[i12]
   add     eax,30
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .points_rot,eax
   jmp     .ff


  .no_crop_front:
   mov     ecx,64
   mov     eax,.only_front   ; th no
   imul    ecx,eax

   xor     ebx,ebx
   mov     .start0,ecx
   mov     .start1,ebx
   mov     .start2,ebx
   mov     ebx,257
   add     ecx,64
   inc     ecx
   mov     .end0,ecx
   mov     .end1,ebx
   mov     .end2,ebx
   mov     .step,32

   shl     eax,4
   add     eax,thread_params
   push    dword[eax]
   pop     .z_buff
   push    dword[eax+4]
   pop     .prj_buff
   push    dword[eax+8]
   pop     .tri_buff
   push    dword[eax+12]
   pop     .points_rot
   mov     edi,[points_r_ptr]
   mov     .vert_to_prj,edi
  .ff:




   mov     ecx,[triangles_count_var]
   mov     edi,.tri_buff
   xor     eax,eax
   shr     ecx,2
   add     ecx,3000
   call    fill_aligned


; Do paralell projection.
; Render faces with index of face as a color.
  push    .start0
  pop     .side0
 .next_side0:
  push    .start1
  pop     .side1
 .next_side1:
  push    .start2
  pop     .side2
 .next_side2:
   fninit
   fld   [one_deg]
   fld   st
   fimul .side0   ; z
   fsincos
   fstp  .sinx
   fstp  .cosx
   fld   st
   fimul .side1 ; x
   fsincos
   fstp  .siny
   fstp  .cosy
   fimul .side2 ; y
   fsincos
   fstp  .sinz
   fstp  .cosz

   pushad
   push   .sinx
   push   .cosx
   push   .siny
   push   .cosy
   push   .sinz
   push   .cosz
   lea    edi,.matrix
   call   make_rotation_matrix
   popad

   push   ebp
;   cmp    .only_front,1
;   je     @f

;   mov    esi,[points_r_ptr]           ; rotate normals
;   jmp    .f
;  @@:
   mov    esi,.vert_to_prj   ; vertices to project
;  .f:
   mov    edi,.points_rot
   mov    ecx,[points_count_var]
   lea    ebx,.matrix
   call   rotary
   pop ebp

   mov     ecx,1000*1000
   mov     edi,.prj_buff
   mov     eax,-1
   call    fill_aligned

   mov     ecx,1000*1000
   mov     edi,.z_buff
   mov     eax,6000.1
   call    fill_aligned
 ;  int3
   mov    esi,[triangles_ptr]
   xor    edx,edx
  .rd:  ; render
;   int3
   push   esi
   push   edx
   push   ebp
   mov    eax,[esi]
   mov    ebx,[esi+4]
   mov    ecx,[esi+8]
   imul   eax,[i12]
   imul   ebx,[i12]
   imul   ecx,[i12]
   add    eax,.points_rot
   add    ebx,.points_rot
   add    ecx,.points_rot
   push   dword 1000     ; x, y prj scr size
   push   dword 1000
   movups xmm0,[eax]
   movups xmm1,[ebx]
   movups xmm2,[ecx]

  .dn:
   mulps  xmm0,[f490x3]
   mulps  xmm1,[f490x3]
   mulps  xmm2,[f490x3]
   addps  xmm0,[f500x3]
   addps  xmm1,[f500x3]
   addps  xmm2,[f500x3]
   movhlps xmm3,xmm0
   movhlps xmm4,xmm1
   movhlps xmm5,xmm2
   movd   ecx,xmm3
   movd   ebx,xmm4
   movd   eax,xmm5
   push   eax
   push   ebx
   push   ecx


   cvtps2dq xmm0,xmm0
   cvtps2dq xmm1,xmm1
   cvtps2dq xmm2,xmm2
   packssdw xmm0,[the_zero]
   packssdw xmm1,[the_zero]
   packssdw xmm2,[the_zero]
   movd   eax,xmm0
   movd   ebx,xmm1
   movd   ecx,xmm2
   mov    esi,.z_buff
   mov    edi,.prj_buff
   call   flat_triangle_z_float
   pop    ebp
   pop    edx
   pop    esi
   add    esi,12
   inc    edx
   cmp    edx,[triangles_count_var]
   jne    .rd

; check if tri index in buff
   mov    esi,.prj_buff
   mov    ecx,1000*1000
 .chck:
   mov    edi,[esi]
   cmp    edi,[triangles_count_var]
   jae    @f
   cmp    edi,-1
   je     @f
   add    edi,.tri_buff
   mov    byte[edi],1    ; 1 - tri outside, 0 - inside
  @@:
   add    esi,4
   loop   .chck

   mov     ecx,.step
   add    .side2,ecx
   mov     ebx,.end2
   cmp    .side2,ebx
   jng    .next_side2

   add    .side1,ecx
   mov     ebx,.end1
   cmp    .side1,ebx
   jng    .next_side1

   add    .side0,ecx
   mov     ebx,.end0
   cmp    .side0,ebx
   jng    .next_side0

   cmp    .only_front,-1   ; only front faces ?
   jne    .end

 ;  count triangles outside
   mov    esi,.tri_buff
   mov    ecx,[triangles_count_var]
   xor    ebx,ebx
  .cnt:
   cmp    byte[esi],1
   jne    @f
   inc    ebx
  @@:
   inc    esi
   loop   .cnt
   mov    .tri_count,ebx
   imul   ebx,[i12]
   add    ebx,1024


   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri,eax

   mov    ebx,.tri_buff  ; renew triangles list
   mov    esi,[triangles_ptr]
   mov    edi,.tri
   mov    ecx,[triangles_count_var]
 .move:
   cmp    byte[ebx],1
   jne    @f
   movdqu xmm0,[esi]
   movq   [edi],xmm0
   psrldq xmm0,8
   movd   [edi+8],xmm0
   add    edi,12
  @@:
   add    esi,12
   inc    ebx
   loop   .move

   invoke   VirtualFree ,[triangles_ptr] ,0 , MEM_RELEASE

   invoke   VirtualFree ,.tri_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.prj_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.z_buff ,0 , MEM_RELEASE


   push   .tri
   pop    [triangles_ptr]
   push   .tri_count
   pop    [triangles_count_var]

   cls
  .end:
   mov    esp,ebp
   pop    ebp

ret


;===============================================================

do_edges_list:
    push    ebp
    mov     ebp,esp
    sub     esp,32

    .ed_cnt  equ [ebp-4]
    .ed_ptr  equ [ebp-8]
    .counter equ [ebp-12]

    prompt  prompt_edges

    mov     ebx,[edges_ptr]
    mov     eax,[triangles_ptr]
    mov     ecx,[triangles_count_var]
  @@:
    movdqu  xmm0,[eax]
    movq    [ebx],xmm0
    pshufd  xmm0,xmm0,11001001b
    movq    [ebx+8],xmm0
    pshufd  xmm0,xmm0,11001001b
    movq    [ebx+16],xmm0
    add     ebx,24
    add     eax,12
    loop    @b

if 0  ; sse 4

    mov     ebx,[edges_ptr]
    mov     ecx,[triangles_count_var]
    mov     edx,ecx
    and     edx,1b
    shr     ecx,1
  @@:
    movdqa    xmm0,[ebx]
    pshufd    xmm0,xmm0,10110001b
    movdqa    xmm1,xmm0
    pmaxud    xmm0,[ebx]
    pminud    xmm1,[ebx]
    pshufd    xmm0,xmm0,11111000b
    pshufd    xmm1,xmm1,11111000b
    punpckldq xmm1,xmm0
    movdqa    [ebx],xmm1
    add       ebx,16
    loop      @b

    cmp       edx,1
    jne       @f
    movq      xmm0,[ebx]
    pshufd    xmm0,xmm0,11100001b
    movdqa    xmm0,xmm1
    pmaxud    xmm0,[ebx]
    pminud    xmm1,[ebx]
    punpckldq xmm1,xmm0
    movq      [ebx],xmm1
  @@:
end if


    mov     ebx,[edges_ptr]
    mov     ecx,[triangles_count_var]
    lea     ecx,[ecx*3]
  .mxd:
    mov     eax,[ebx]
    cmp     eax,[ebx+4]
    jl      @f
    movq    xmm0,[ebx]
    pshufd  xmm0,xmm0,11100001b
    movq    [ebx],xmm0
  @@:
    add     ebx,8
    loop    .mxd


   ; insert sort
   mov    ebx,[edges_ptr]
   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3]

   mov    esi,ecx
   shl    esi,3
   add    esi,ebx

 .ccc:
   mov    eax,[ebx+8]
   cmp    eax,[ebx]
   jge    .g
   movq   xmm0,[ebx+8]
   push   ebx
 .c:
   cmp    ebx,esi
   jge    .done
   cmp    ebx,[edges_ptr]
   jl     .done
   cmp    eax,[ebx]
   jge    .done
   movq   xmm7,[ebx]
   movq   [ebx+8],xmm7
   sub    ebx,8
   jnz    .c
   add    ebx,8
 .done:
   movq   [ebx+8],xmm0
 .p:
   pop    ebx
 .g:
   add    ebx,8
   dec    ecx
   cmp    ecx,1
   jnz    .ccc


  ; insert sort again
   mov    ebx,[edges_ptr]
   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3]
   mov    esi,ecx
   shl    esi,3
   add    esi,ebx

 .count:
   push   ecx
   push   ebx
   xor    ecx,ecx
   mov    eax,[ebx]          ; count
 .aa:
   inc    ecx
   add    ebx,8
   cmp    ebx,esi
   jge    .br         ; break
   cmp    eax,[ebx]
   je     .aa
   mov    .counter,ecx
   pop    ebx
   mov    edi,ebx
   sub    edi,8
   mov    edx,[ebx+8]
 .ccc2:

   cmp    ebx,esi
   jbe    @f
   add    esp,4
   jmp    .ff
 @@:
   mov    eax,[ebx+12]
   mov    edx,[ebx+8]
   cmp    eax,[ebx+4]
   jge    .g2
   movq   xmm0,[ebx+8]
   push   ebx
 .c2:
   cmp    eax,[ebx+4]
   jge    .done2
   movq   xmm7,[ebx]
   movq   [ebx+8],xmm7

   sub    ebx,8
   cmp    ebx,edi
   jz     @f
   cmp    [ebx+8],edx
   jz     .c2
 @@:
 .done2:
   add    ebx,8
   movq   [ebx],xmm0

 .p2:
   pop    ebx
 .g2:
   add    ebx,8
   dec    ecx
   cmp    ecx,1
   jnz    .ccc2

   pop    ecx
   sub    ecx,.counter
   add    ebx,8
   ja     .count

   jmp    .ff
 .br: ;break
   add   esp,8
 .ff:

   ; count edges
   mov    ecx,0
   mov    edx,[triangles_count_var]
   lea    edx,[edx*3]
   mov    ebx,[edges_ptr]
;   mov    esi,edx
;   shl    esi,3
;   add    esi,[edges_ptr]
 .nx:
   movq    xmm0,[ebx]
   add     ebx,8
;   cmp     ebx,esi
;   jae     @f
   movq    xmm1,[ebx]
; @@:
   pcmpeqd xmm0,xmm1
   pmovmskb eax,xmm0
   and     eax,0xff
   cmp     eax,0xff
   jz      @f
   inc     ecx
  @@:
   dec     edx
   jnz     .nx

   mov     .ed_cnt,ecx
   mov     ecx,[triangles_count_var]
   lea     ecx,[ecx*3]
   shl     ecx,3
   add     ecx,65536
   invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .ed_ptr,eax

   mov      ebx,[edges_ptr]
   mov      ecx,[triangles_count_var]
   lea      ecx,[ecx*3]
  .seek:
   movq     xmm0,[ebx]
   movq     xmm1,[ebx+8]
   pcmpeqd  xmm1,xmm0
   pmovmskb edx,xmm1
   and      edx,0xff
   cmp      edx,0xff
   je       @f
   movq     [eax],xmm0
   add      eax,8
 @@:
   add      ebx,8
   loop     .seek

   invoke   VirtualFree ,[edges_ptr] ,0 , MEM_RELEASE

   mov      eax,.ed_ptr
   mov      ecx,.ed_cnt
   mov      [edges_ptr],eax
   mov      [edges_count],ecx

   cls

   mov      esp,ebp
   pop      ebp
ret

;=================================================================

remove_redundant_vert:    ; remove redundand vertices
; in:
;     registers:
;        eax - approximation tolerancy (as dword float)
;     globals:
;        points_r_ptr, triangles_ptr, points_normals_ptr
;        points_count_var, triangles_count_var
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov  ebp,esp
   sub  esp,256
   and  ebp,-16

   .new_vertices_ptr     equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .old_vertices_ptr     equ dword[ebp-8]
   .cnt_new_vert         equ dword[ebp-12]
   .cnt_old_vert         equ dword[ebp-16]
   .red_table_ind        equ dword[ebp-20]
   .cur_new_vertices_ptr equ dword[ebp-24] ;ptr of indexes of reedundant vertices
   .cnt_vert             equ dword[ebp-28]
   .temp_tri_ptr         equ dword[ebp-32]  ; tri list with one byte pro index
                                            ; for mark purposes
   .points_count_var     equ dword[ebp-36]
   .triangles_count_var  equ dword[ebp-40]
   .points_r_ptr         equ dword[ebp-44]
   .triangles_ptr        equ dword[ebp-48]
   .merge_mark           equ dword[ebp-64]
   .aprox_vert           equ [ebp-80]     ; tolerancy
   .aprox_norm           equ [ebp-96]
   .cn                   equ [ebp-112]    ; cur normal
   .cn_ptr               equ dword[ebp-116]
   .index_nv             equ dword[ebp-120]
   .first_index          equ [ebp-124]
   .second_index         equ [ebp-128]
   .second_vert          equ [ebp-128-16]

    ; set approximation tolerancy
   movd    xmm7,eax

   prompt  prompt_red_vert

   shufps  xmm7,xmm7,0
   movaps   .aprox_vert,xmm7

   mov     .merge_mark,0
   cmp     [nr_care_flag],0 ; care about normal ?
   je      @f
   mov     ebx,0.00006
   movd    xmm5,ebx
   shufps  xmm5,xmm5,0
   movaps  .aprox_norm,xmm5
   mov     .merge_mark,-1
 @@:
   push  [points_count_var]     ; init some local data
   pop   .points_count_var
   push  [triangles_count_var]
   pop   .triangles_count_var
   push  [points_r_ptr]
   pop   .points_r_ptr
   push  [triangles_ptr]
   pop   .triangles_ptr
if 0
  ; Go across the vertices list and find close vertices
  ; according to aproximation tolerancy value.
  ; For all found 'near' enough vertices, swap theys index in
  ; triangles list to vertex you actually compare.(You may also
  ; calculate theys mid value and insert in vertices list).
  ; Finally remove unused vertices. Make routintes ready to
  ; add merging triangle option.

  ; Maybye instead rewriting all proc, wriite an remove unused
  ; triangles rout... Triangles with redundant indexes

  mov    esi,[points_r_ptr]
  xor    ecx,ecx

  movups   xmm0,[esi]
  andps    xmm0,[zero_hgst_dd]
  movaps   xmm1,xmm0
  subps    xmm1,xmm7
  addps    xmm0,xmm7

  .reep:
  movups   xmm2,[esi]
  movups   xmm3,[esi]
  cmppslt  xmm2,xmm0
  cmppsnlt xmm3,xmm1
  xorps    xmm3,xmm2


  movaps   xmm1,[esi]
  movaps   xmm1,xmm0
  subps    xmm0,xmm7
  subps    xmm1,xmm7

end if
   ; alloc mem for new lists
   mov     eax,.triangles_count_var
   mul     [i15]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .temp_tri_ptr,eax

   mov     eax,.points_count_var
   shl     eax,4
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  ; int3
 @@:
   mov    .new_vertices_ptr,eax

   mov     eax,.points_count_var
   shl     eax,4
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .old_vertices_ptr,eax

   mov   esi,.points_r_ptr
   mov   edi,.old_vertices_ptr
   mov   ecx,.points_count_var
 @@:
   movups xmm0,[esi]
   movaps [edi],xmm0
   mov    dword[edi+12],0x0 ; index and mark stamp
   add    esi,12
   add    edi,16
   sub    ecx,1
   jnz    @b

 if 0
   mov    esi,[edges_ptr]
   mov    ecx,[edges_count]       ; not joining
   mov   edi,.old_vertices_ptr
  .check_edge:
   mov    eax,[esi]               ; only merging
   mov    ebx,[esi+4]
   imul   eax,[i12]
   imul   ebx,[i12]
   add    eax,.points_r_ptr
   add    ebx,.points_r_ptr
   movups xmm0,[eax]
   movups xmm1,[ebx]
   movups xmm2,[eax]
   subps  xmm2,[aprox_vert]
   addps  xmm0,[aprox_vert]
   cmpgtps xmm2,xmm1
   cmpgtps xmm0,xmm1
   xorps   xmm0,xmm2
   movmskps edx,xmm0
   and     edx,111b
   cmp     edx,111b
   jne     .frw
   mov    edi

  .frw:
   loop    .check_edge
end if

   mov      ebx,.old_vertices_ptr  ;[points_r_ptr]
   xor      ecx,ecx
   push     .new_vertices_ptr
   pop      .cur_new_vertices_ptr
   push     [points_normals_ptr]
   pop      .cn_ptr

 .next_vert:
   push     ecx
   mov      .first_index,ecx
   mov      .cnt_old_vert,ecx
   mov      ecx,.cn_ptr
   movups   xmm7,[ecx]
   movaps   .cn,xmm7   ; cur normal
   movaps   xmm0,[ebx]

   cmp      dword[ebx+12],-1 ; mark
   je       .non_vertex

   mov      edx,.new_vertices_ptr
   mov      edi,[points_normals_ptr]
   xor      ecx,ecx
 .look_for_red:
   push     ecx
   mov      .index_nv,ecx
   cmp      dword[edx+12],-1
   je       .red_not_found  ; [edx+12] marked if redundant
   push     dword[edx+12]
   pop      dword .second_index
   movaps   xmm1,xmm0
   movaps   xmm6,xmm0
   subps    xmm1,.aprox_vert
   addps    xmm6,.aprox_vert
   cmpltps  xmm1,[edx]
   cmpltps  xmm6,[edx]
   xorps    xmm1,xmm6
;   movaps   xmm7,[edx]  ; xmm7 second vert
;   movaps   .second_vert,xmm7

   movmskps eax,xmm1
   and      eax,0111b
   cmp      eax,0111b
   jne      .red_not_found  ; redundant vetexr found ->
                            ; -> ecx - its index
   cmp      .merge_mark,0
   je       .ff               ; merge triangles cause

   movaps   xmm1,.cn         ; according to normal vect
   movaps   xmm6,.cn
   subps    xmm1,.aprox_norm
   addps    xmm6,.aprox_norm   ; check normal vect
   movups   xmm2,[edi]
   cmpltps  xmm1,xmm2
   cmpltps  xmm6,xmm2
   xorps    xmm1,xmm6
   movmskps eax,xmm1
   and      eax,0111b
   cmp      eax,0111b
   jne      .red_not_found

   mov      esi,[edges_ptr]
   push     edi
   push     ecx
   mov      ecx,[edges_count]
   shr      ecx,2   ; 4 edges per turn
 .check_edge:
   movq     xmm1,.second_index
   pshufd   xmm1,xmm1,01000100b
   movaps   xmm2,xmm1
   pshufd   xmm2,xmm2,00010001b
   movaps   xmm3,xmm2
   movaps   xmm4,xmm1

   pcmpeqd  xmm1,[esi]
   pcmpeqd  xmm2,[esi]
   pcmpeqd  xmm3,[esi+16]
   pcmpeqd  xmm4,[esi+16]
   movaps   xmm5,xmm1
   pshufd   xmm5,xmm5,10110001b
   pand     xmm1,xmm5
   movaps   xmm5,xmm2
   pshufd   xmm5,xmm5,10110001b
   pand     xmm2,xmm5
   movaps   xmm5,xmm3
   pshufd   xmm5,xmm5,10110001b
   pand     xmm3,xmm5
   movaps   xmm5,xmm4
   pshufd   xmm5,xmm5,10110001b
   pand     xmm4,xmm5
   por      xmm1,xmm2
   por      xmm3,xmm4
   por      xmm1,xmm3
   pmovmskb eax,xmm1
;   pmovmskb edi,xmm1
   add      esi,32
 ;  ror      edi,16
 ;  or       eax,edi
   or       al,ah
   and      eax,0xff
   cmp      eax,0xff
   je       @f
   dec      ecx
   jnz      .check_edge
   pop      ecx
   pop      edi
   jmp      .red_not_found
 @@:
   pop      ecx
   pop      edi

  .ff:
 ;  mov     esi,[edges_ptr]
 ;  movd    xmm0,ecx
 ;  pshufd  xmm0,xmm0,0
 ;  pcmpeqd xmm0,[esi]
 ;  cmp     [esi],ecx
 ;  je      @f
 ;
 ; @@:

   mov     dword[edx+12],-1   ; mark red
  ; renew triangles list
   mov     esi,.triangles_ptr
   mov     eax,ecx
   mov     ecx,.triangles_count_var
   lea     ecx,[ecx*3]
 .next:
   cmp     dword[esi],eax
   jne     @f
   push    .cnt_old_vert
   pop     dword[esi]
  @@:
   add     esi,4
   sub     ecx,1
   jnz     .next

 .red_not_found:
   pop     ecx
   add     ecx,1
   add     edx,16 ;  ;12
   add     edi,12
   cmp     ecx,.points_count_var
   jne     .look_for_red       ; look for redundant


   mov     eax,.cur_new_vertices_ptr
;   subps   xmm0,.second_vert      ; xmm7 second vert
;   divps   xmm0,[f2x4]
;   addps   xmm0,.second_vert



   movaps  [eax],xmm0
   push    .cnt_old_vert
   pop     dword[eax+12]
   add     .cur_new_vertices_ptr,16
 .non_vertex:
   add     ebx,16
   add     .cn_ptr,12
   pop     ecx
   add     ecx,1
   cmp     ecx,.points_count_var
   jne     .next_vert
; w liscie new_vert sa nowe vertexy i ich stary indeks
; lista triang tez wymaga poprawienia na nowe indeksy

; in the list pointed by .new_vertices_ptr are new
; vertices and its old index, list pointed by triangles_ptr need
; renew too, instead old, it will be new indexes

  mov    ecx,.triangles_count_var
  lea    ecx,[ecx*3]
  mov    esi,.triangles_ptr
  mov    edi,.temp_tri_ptr
 @@:
  push   dword[esi]
  pop    dword[edi]
  mov    byte[edi+4],0
  add    esi,4
  add    edi,5
  sub    ecx,1
  jnz    @b

  mov    esi,.new_vertices_ptr
  mov    .cnt_vert,0
 .next_new_vert:
  mov    eax,dword[esi+12]
  cmp    eax,-1  ; check if redundant
  je     .skip_vrt
  xor    ecx,ecx
  mov    edx,.temp_tri_ptr
  mov    ebx,.triangles_count_var
  lea    ebx,[ebx*3]
 .next_index:
  cmp    [edx],eax
  jne    @f
  cmp    byte[edx+4],0  ; was the index previously changed ?
  jne    @f
  push   .cnt_vert
  pop    dword[edx]
  mov    byte[edx+4],0xff
 @@:
  add    edx,5
  add    ecx,1
  cmp    ecx,ebx
  jne    .next_index
  add    .cnt_vert,1
 .skip_vrt:
  add    esi,16
  cmp    esi,.cur_new_vertices_ptr
  jle    .next_new_vert

  mov      esi,.temp_tri_ptr   ; save desired data in 'global' list
  mov      edi,.triangles_ptr
  mov      ecx,.triangles_count_var
  xor      ebx,ebx

 .check_dead_tri:
  movdqu   xmm0,[esi]
  movdqa   xmm1,xmm0
  movdqa   xmm2,xmm0
  psrldq   xmm1,1
  psrldq   xmm2,2
  pand     xmm0,[mask1]
  pand     xmm1,[mask2]
  pand     xmm2,[mask3]
  por      xmm0,xmm1
  por      xmm0,xmm2

  movdqa   xmm1,xmm0
  pshufd   xmm0,xmm0,11010010b
  pcmpeqd  xmm0,xmm1
  pmovmskb eax,xmm0
  and      eax,0x0fff
  or       eax,eax
  jnz      .f

 .do_add:
  add      ebx,1
  movdqu   [edi],xmm1
  add      edi,12
 .f:
  add      esi,15
  sub      ecx,1
  jnz     .check_dead_tri

  mov      .triangles_count_var,ebx
;  renew list pointed by [points_r_ptr]
  mov      esi,.new_vertices_ptr
  mov      edi,.points_r_ptr
  xor      ecx,ecx
  xor      edx,edx
 .again:
  movups   xmm0,[esi]
  cmp      dword[esi+12],-1
  je       .skip
  movlps   [edi],xmm0
  movhlps  xmm0,xmm0
  movss    [edi+8],xmm0
  add      edx,1
  add      edi,12
 .skip:
  add      esi,16
  add      ecx,1
  cmp      ecx,.points_count_var
  jnz      .again
  mov      [points_count_var],edx

  push     .triangles_count_var
  pop      [triangles_count_var]
  invoke   VirtualFree ,.new_vertices_ptr ,0 , MEM_RELEASE
  invoke   VirtualFree ,.old_vertices_ptr ,0 , MEM_RELEASE
  invoke   VirtualFree ,.temp_tri_ptr ,0 , MEM_RELEASE

  cls      ;macro
  add      esp,256
  pop      ebp
ret

;===========================================================================
draw_triangulize_rect:
    ;at 1st clear teslate area buff
    xor   eax,eax          ; clear
    mov   edi,[edit_tri_area_ptr]
    movzx ebx,[xres_var]
    movzx ecx,[yres_var]
    imul  ecx,ebx
    shr   ecx,4
    call  fill_aligned

    movups    xmm0,dqword[tri_area_x1]
    cvtps2dq  xmm0,xmm0
    shufps    xmm0,xmm0,11011000b
    packssdw  xmm0,xmm0
    movd      eax,xmm0
    psrldq    xmm0,4
    movd      ebx,xmm0

    movd     mm1,[screen_ptr]
    pxor     xmm6,xmm6
   ;  movd     mm0,[Zbuffer_ptr]
    movzx    ecx,[xres_var]
    movd     mm2,ecx
    mov      ecx,0x0000ff00
    movd     mm3,ecx
    movd     xmm7,[xres_vard]
    punpcklwd xmm7,xmm6
    call      write_framee
    mov       ecx,1         ; other const mark
    movlps    xmm0,qword[tri_area_x1]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_tri_area

    mov       ecx,0
    movlps    xmm0,qword[tri_area_x2]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_tri_area
ret

;============================================================
bar_tri_area:
 ;  ecx - signature - 0 / 1
 ;  xmm0 - coordinates
 ;  edx  - yresm4
 ;  esi  - xresm4
    push     ebp
    mov      ebp,esp

    .xresm4   equ ebp-4
    .yresm4   equ ebp-8
    .ed       equ ebp-12
    .add_tb   equ ebp-16
    .add      equ ebp-20

    push     edx
    push     esi
    push     ecx
    movzx    eax,[xres_var]
    sub      eax,6
;    shl      eax,2
    push     eax
    shl      eax,2
    push     eax

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,5
    jle      .skip
    cmp      ebx,5
    jle      .skip
    cmp      ebx,dword[.yresm4]
    jge      .skip
    cmp      eax,dword[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    mov      eax,ebx
    shl      eax,2
    mov      edi,eax
    add      edi,[screen_ptr]
    and      dword[.ed],1b
  ;  draw bar 6x6
    mov      eax,6

 .oop_ed:
    push     eax
    mov      eax,6
  .oop1:
    push     ebx
    mov      ecx,ebx
    shr      ebx,2
    and      ecx,11b
    add      ebx,[edit_tri_area_ptr]
    mov      dword[edi],0x00ffff00
    add      ecx,ecx
    inc      ecx
    cmp      dword[.ed],0
    jne      @f
    bts      [ebx],ecx
    jmp      .f
  @@:
    inc      ecx
    bts      [ebx],ecx
  .f:
    pop      ebx
    add      ebx,1
    add      edi,4
    dec      eax
    jnz      .oop1
    add      edi,[.add]
    add      ebx,[.add_tb]
    pop      eax
    dec      eax
    jnz     .oop_ed
  .skip:
   mov       esp,ebp
   pop       ebp
ret


;==========================================================
calc_shadow:  ; calc shadow 4X4 matrix
 ; in esi -> light vector - ptr to 3 dwords float
 ;    ebx -> ptr to 4x4 shadow matrix 16 dwords, 64 bytes
 movups xmm1,[plane_equation]
 movups xmm0,[esi]
 andps  xmm0,[zero_hgst_dd]
 orps   xmm0,[one_hgst_dd]
 movaps xmm2,xmm0  ; xmm2 light vector
 mulps  xmm0,xmm1
 haddps xmm0,xmm0
 haddps xmm0,xmm0
 movaps xmm4,xmm0  ; xmm4 - dot product

 ; do 4x4 shadow matrix
 movss  xmm3,[plane_equation]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx],xmm3
 addss  xmm3,xmm4
 movss  [ebx],xmm3

 movss  xmm3,[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss  xmm3,xmm4
 movss  [ebx+20],xmm3

 movss  xmm3,[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss  xmm3,xmm4
 movss  [ebx+40],xmm3

 movss  xmm3,[plane_equation+12]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+48],xmm3
 shufps xmm3,xmm3,00100111b
 addss  xmm3,xmm4
 movss  [ebx+60],xmm3      ; finaly matrix done
ret


if 0
calc_p_light_coords:
; in   - none
; out  - xmm1 -> light position
; uses - edx, xmm0, xmm1, xmm3
    movups   xmm0,[point_light]   ;     calculate light coords.
    movzx    edx,[xres_var]
    cvtsi2ss xmm1,edx
    shufps   xmm1,xmm1,11000000b
    mulps    xmm1,xmm0

    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    subps    xmm1,xmm3
  ;  addps    xmm1,xmm1      ; xmm1 - first point light position
    movups   [point_light_coords],xmm1
ret
end if
;==============================================
xy_in_rect:

 ; in:
 ; eax - current y shl 16 + x
 ; ecx - y1 shl 16 + x1
 ; edx - y2 shl 16 + x2
 ;out:
 ; ebx = 0 no, ebx = 1 yes
  movd  xmm0,eax
  movd  xmm1,ecx
  movd  xmm2,edx
  pcmpgtw  xmm1,xmm0
  pcmpgtw  xmm2,xmm0
  pxor     xmm2,xmm1
  pmovmskb ebx,xmm2
  cmp      ebx,1111b
  jne     .end_no
  mov   ebx,1
  ret
 .end_no:
  xor  ebx,ebx
ret

;===========================================================
move_texture:
 ;  eax - move x
 ;  ebx - move y
    push ebp

    .x_tex   equ  [ebp-6]
    .y_tex   equ  [ebp-4]
    mov   ebp,esp
    sub   esp,64
    mov   .x_tex,ax
    mov   .y_tex,bx
    cmp   ebx,0
    je    .xx
    jl    .ysub      ;jl

    mov   eax,ebx
    mov   edx,TEX_X
    mul   edx
    mov   ebx,eax
    shl   ebx,2
    lea   esi,[texmap+ebx]
    lea   edi,[texmap]
  ;  cld
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  ;  rep   movsd
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   esi,4
    add   edi,4
    sub   ecx,1
    jnz   @b
    jmp   .xx
 .ysub:
    mov   esi,texmap
    add   esi,TEX_X*TEX_Y*4
    mov   edi,esi
    neg   ebx
    mov   eax,TEX_X
    mul   ebx
    lea   ecx,[eax*4]
    sub   esi,ecx
  ;  std
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    sub   ecx,1
    jnz   @b
 ;   rep   movsd
  .xx:
    cmp   word .x_tex,0
    je    .end
    jl    .xadd
    movzx eax,word .x_tex
 ;   neg   eax
    lea   edx,[eax*4]
  ;  cld
    xor   ebx,ebx
    lea   esi,[texmap+edx]
    lea   edi,[texmap]
  .next_xsub_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   edi,4
    add   esi,4
    loop  @b
   ; rep   movsd

    add   esi,edx
    add   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .next_xsub_l
    jmp   .end

   .xadd:

    movsx eax, word .x_tex
    neg   eax

    lea   edx,[eax*4]
  ;  std
    xor   ebx,ebx
    lea   esi,[texmap+TEX_X*TEX_Y*4]
    mov   edi,esi
    sub   esi,edx
  @@:
 .nextxadd_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    loop  @b
  ;  rep   movsd
    sub   esi,edx
    sub   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .nextxadd_l;@b

  .end:
   mov    esp,ebp
   pop   ebp
ret
;==============================================================
apply_displacement_from_tex:
.vert1_ptr equ dword[ebp-4]
.vert2_ptr equ dword[ebp-8]
.vert3_ptr equ dword[ebp-12]
.fact      equ [ebp-16]

        push  ebp
        mov   ebp,esp
        sub   esp,16


        cvtsi2ss xmm5,[displac_div]
        rcpss    xmm5,xmm5
        movss    .fact,xmm5


        prompt prompt_displ
        xor    ecx,ecx
      .next_vert:
        push   ecx                      ; ecx - vertex counter
        mov    ebx,ecx
        imul   ebx,[i12]
        mov    edi,ebx
        add    edi,[points_normals_rotated_ptr]
        add    ebx,[points_r_ptr]
        movups xmm0,[ebx]
        mov    .vert1_ptr,ebx

        mov    esi,ecx
        mov    eax,ecx
        shl    eax,2
        add    eax,[tex_points_ptr]
        mov    ecx,eax
        movzx  eax,word[eax+2] ; tex y
        mov    edx,TEX_X
        mul    edx
        movzx  ecx,word[ecx]   ; tex x
        add    ecx,eax
        shl    ecx,2
        add    ecx,texmap
        mov    eax,ecx
        mov    ecx,[ecx]
        and    ecx,0x00ffffff
        cmp    ecx,[displ_transparent_col]  ;0x00ffffff
        je     .no  ; no change if transparent - white color
        cmp    [td_wp_flag],0  ; only vertices with positive normal z
                               ; cooficient are computed or all vertices ?
        jz     .whole
        test   dword[edi+8],0x80000000   ; check sign of z coof
        jz     .no
      .whole:
        movzx  ecx,byte[eax]   ; read R,G,B pixel
        movzx  ebx,byte[eax+1]
        add    ecx,ebx
        movzx  ebx,byte[eax+2]
        add    ecx,ebx



        mov    eax,esi
        imul   eax,[i12]
        add    eax,[points_normals_ptr]
        movups xmm7,[eax]
        cvtsi2ss xmm6,ecx

        mulss   xmm6,.fact
        shufps  xmm6,xmm6,0

        mulps   xmm7,xmm6
        addps   xmm0,xmm7
        mov     ebx,.vert1_ptr
        movlps  [ebx],xmm0
        movhlps xmm0,xmm0
        movss   [ebx+8],xmm0
      .no:

        pop    ecx
        inc    ecx
        cmp    ecx,[points_count_var]
        jnz    .next_vert
        cls
        mov    esp,ebp
        pop    ebp

ret


;===========================================================

load_tetrahedron:

    mov   esi,tetra_points_r
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,tetra_points_count*3 + 1
  @@:
    rep   movsd
;    fild  word[esi]
;    fstp  dword[edi]
;    add   esi,2
;    add   edi,4
;    loop  @b
;    movsd

    mov   esi,tetra_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,tetra_triangles_count*12 + 2
  @@:
    movzx eax,word[esi]
    mov   [edi],eax
    add   esi,2
    add   edi,4
    loop  @b
   ; rep   movsw


    mov   ecx,tetra_triangles_count * 12 + 1
    mov   esi,tetra_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],tetra_triangles_count
    mov  [points_count_var],tetra_points_count
ret

;================================================================
blur_screen:
;blur n times  ; blur or fire
;in - ecx  times count

.counter1 equ dword[esp-8]

         push       ebp
         mov        ebp,esp
         movaps     xmm5,[blur_sub]
     .again_blur:
         push       ecx
         mov        edi,[screen_ptr]
         movzx      ecx,[xres_var]  ;SIZE_X
         xor        eax,eax
         rep        stosd
;         add        edi,16
;         and        edi,-16
         movzx      ecx,[xres_var]  ;SIZE_X
         movzx      ebx,[yres_var]  ;SIZE_X
         sub        ebx,4
         imul       ecx,ebx
         shr        ecx,2
         movzx      ebx,[xres_var]  ;SIZE_X
  ;       mov        ecx,(SIZE_X*(SIZE_Y-4))*4/16
         mov        esi,edi
         mov        edx,ebx
         shl        edx,2
         sub        esi,edx
     .blr:
     @@:
         movaps     xmm0,[edi+ebx*4]
     ;    movaps     xmm1,[esi];[edi-ebx*4]
         movaps     xmm2,[edi-16]
     ;    movaps     xmm3,[edi+16]

         pavgb      xmm0,[esi]
         pavgb      xmm2,[edi+16]
         pavgb      xmm0,xmm2

         psubusb    xmm0,xmm5  ; importand if fire

         movaps     [edi],xmm0
         add        edi,16
         add        esi,16

         loop       .blr

         xor        eax,eax
         movzx      ecx,[xres_var] ;SIZE_X
         rep        stosd
         pop        ecx
         loop       .again_blur
         mov        esp,ebp
         pop        ebp
ret
;===========================================================
normalize_object1:  ; procedure don't save registers !!
; do mesh coords in from -1.0 to 1.0
; in:   stack 1 - vertices count to normalise
;       stack 2 - pointer to vertices
; out:  xmm7 - broadcasted reciprocal of maxscale
;       xmm0 - center

        .points_count equ ebp+4
        .points_r     equ ebp+8

       mov   ebp,esp
       mov  ecx,[.points_count]
       sub  ecx,1
       mov  edi,[.points_r]

       movups  xmm0,[edi]
       movups  xmm2,[edi]
     @@:
       movups  xmm1,[edi+12]
       maxps   xmm0,xmm1
       minps   xmm2,xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b
       movaps  xmm3,xmm0   ; scale
       subps   xmm0,xmm2
       divps   xmm0,[f2x4]
       subps   xmm3,xmm0   ; xmm3 - this we sub from all

       movaps  xmm4,xmm0
       movaps  xmm5,xmm0
       shufps  xmm4,xmm4,11100001b
       shufps  xmm5,xmm5,11000110b
       maxss   xmm4,xmm0
       maxss   xmm4,xmm5    ; xmm4 - max scale
       movss   [max_scale],xmm4
       shufps  xmm4,xmm4,0
       rcpps   xmm4,xmm4

       mov     ecx,[.points_count]
  ;     sub     ecx,1
       mov     edi,[.points_r]
     @@:
       movups  xmm0,[edi]
       subps   xmm0,xmm3    ; set 0,0,0 in center
       mulps   xmm0,xmm4    ; scale
       movhlps xmm1,xmm0
       movlps  [edi],xmm0
       movss   [edi+8],xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b

       movaps  xmm7,xmm4
       movaps  xmm0,xmm3

       mov    esp,ebp

ret 8
;=========================================================
generate_texture1:  ; do blank texture uses for smooth objects edges
       mov  edi,texmap
       mov  eax,0xffffffff
       mov  ecx,TEX_X*TEX_Y
       cld
       rep  stosd
ret

generate_texture3:

       mov  edi,texmap
       xor  ecx,ecx
       cld
     .next:
       xor  ebx,ebx
     @@:
       mov  eax,ecx
       mov  edx,ebx
       xor  eax,edx
       mov  ah,al
       push ax
       shl  eax,8
       pop  ax
;       or   eax,0x00f00000
       ;mov  [edi],eax
       ;add  edi,4
       stosd
       inc  ebx
       cmp  ebx,TEX_X
       jne  @b
       inc  ecx
       cmp  ecx,TEX_Y
       jne  .next
ret

generate_texture2:
.const equ 32
        cld
        mov     edi,texmap
        xor     bx,bx
     .next_line:
        xor     dx,dx
     .next2stripes:
        mov     eax,-1
        mov     ecx,(TEX_X/.const)
        rep     stosd
        mov     eax,0x00ff0000
        mov     ecx,(TEX_X/.const)
     @@:
        stosd
        loop    @b
        inc     dx
        cmp     dx,.const/2
        jl      .next2stripes
        inc     bx
        cmp     bx,TEX_Y
        jl      .next_line
ret
;============================================================
calc_bumpmap_coords:      ; map texture, bump

      fninit
      fldpi
      fadd      st,st
      mov       esi,[points_r_ptr]
      mov       edi,[tex_points_ptr]
      mov       ecx,[points_count_var]
  ;    inc       ecx

   .again:
      cmp       [map_flag],2
      jg        .spherical
       ; choose map planar or spherical
       ; map flag 1,2,3 - various planar mapping
      cmp      [map_flag],0
      jne      @f
      xor      eax,eax
      mov      ebx,4
      jmp      .do_planar
  @@:
      cmp      [map_flag],1
      jne      @f
      mov      eax,4
      mov      ebx,8
      jmp      .do_planar
  @@:
;      cmp      [map_flag],3
;      jne      @f
      mov      eax,8
      mov      ebx,4
   .do_planar:
   @@:
      fld       dword[esi+eax]
      fimul     [tex_x_div2]   ; planar map
      fiadd     [tex_x_div2]
      fistp     word[edi]

      fld       dword[esi+ebx]
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi+2]

      add      esi,12
      add      edi,4
      loop     .do_planar

      jmp       .end
;      cmp       [map_tex_flag],1
;      jne       .cylindric
   .spherical:
;
;      cmp      [map_flag],3
;      jne      @f
;      xor      eax,eax
;      mov      ebx,4
;      jmp      .do_sp
;  @@:
;      cmp      [map_flag],4
;      jne      @f
;      mov      eax,4
;      mov      ebx,8
;      jmp      .do_sp
;  @@:
;;      cmp      [map_flag],3
;;      jne      @f
;      mov      eax,8
;      mov      ebx,0
;      ; spherical mapping around y axle
;   .do_sp
   @@:
      fld       dword[esi]     ; x coord
      fld       dword[esi+8]   ; z coord
      fpatan                   ; arctg(st1/st)
;      fdiv      .Pi2
      fdiv      st0,st1
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi]      ; x

      fld       dword[esi+4]   ; y coord
      fld       dword[esi]     ; x
      fmul      st,st0
      fld       dword[esi+4]   ; y
      fmul      st,st0
      fld       dword[esi+8]   ; z
      fmul      st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fistp    word[edi+2]     ; y


      add      esi,12
      add      edi,4
      loop     @b
   .end:
      ffree    st0

ret

;================================================================
calc_bumpmap:            ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

         pushad

         mov     edi, bump_map
         mov     esi,texmap
         mov     ecx,TEXTURE_SIZE
         cmp     [bump_flag],0
         je      .random_bump_map
         ; else bumps according to texture
      @@:
         movzx   ax,byte[esi]
         movzx   bx,byte[esi+1]
         movzx   dx,byte[esi+2]
         add     ax,bx
         add     ax,dx
         cwde
         cdq
         div     [i3]
         stosb
         add     esi,4
         loop    @b
         jmp     .blur_map

  .random_bump_map:

  ;       RDTSC
  ;       mov    [rand_seed],ax
      @@:
         push    ecx
         xor     ecx,ecx
         mov     edx,255
         call    random
         stosb
         pop    ecx
         loop   @b

      .blur_map:

      ;   movzx  ecx,[bumps_deep_flag]
         mov    edi, bump_map
         mov    ecx,4
      .blur:
         xor    esi,esi
         mov    edx,TEXTURE_SIZE
         xor    eax,eax
         xor    ebx,ebx
      @@:
         mov    ebp,esi
         dec    ebp
         and    ebp,TEXTURE_SIZE
         mov    al,byte[ebp+edi]

         mov    ebp,esi
         inc    ebp
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         sub    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         add    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         shr    eax,2
         mov    byte[esi+edi],al

         inc    esi
         dec    edx
         jnz    @b

         loop   .blur
         popad
ret

;================================================================
make_random_lights:
  .temp1  equ ebp-4
  .temp2  equ ebp-8     ;  - light vector generate variables
  .temp3  equ ebp-12
  .col1   equ ebp-20
  .col2   equ ebp-28
  .col3   equ ebp-32
  .max equ 800
;        RDTSC
;        mov    [rand_seed],ax
        push    ebp
        mov     ebp,esp
        sub     esp,64
        mov     edi,lights
        fninit
        mov     dword[.temp2],.max
        mov     dword[.temp3],.max/2

    .again:
        xor     esi,esi
     @@:
        mov     edx,.max
        xor     ecx,ecx
        call    random
        sub     eax,.max/2
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fidiv   dword[.temp3]
        fstp    dword[edi+esi*4]
        inc     esi
        cmp     esi,2
        jne     @b

  .max1 equ 1000
        mov     dword[.temp2],.max1/2
        mov     edx,.max1
        xor     ecx,ecx
        call    random
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fchs
        fidiv   dword[.temp2]
        fstp    dword[edi+8]

        xor     esi,esi
     @@:
        mov     ecx,220            ; max colors and shine  , ecx = 200 - more bright shading
        mov     edx,255
        call    random
        movzx   ax,al
        mov     [edi+28+esi*2],ax
        inc     esi
        cmp     esi,4
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,100              ; orginal colors
        movzx   edx,word[edi+28+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+12+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,1               ; min cols
        movzx   edx,word[edi+12+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+20+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        add     edi,LIGHT_SIZE ;22
        cmp     edi,lightsend
        jne     .again


        mov       esi,lights
        mov       edi,lights_aligned



     .do_aligned: ; make aligned float lights used
                  ; in all Real Phong rendering models
        movups    xmm0,[esi]
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0    ; normalize
        mulps     xmm1,xmm1
        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1


if 0
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm0,eax
        divss     xmm0,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm1,eax
        divss     xmm1,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm2,eax
        divss     xmm2,[f256d]

        shufps    xmm1,xmm1,11100001b
        por       xmm0,xmm1
        movlhps   xmm0,xmm2
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0
        mulps     xmm1,xmm1

        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1
end if


        movq      xmm1,[esi+12]
        movq      xmm2,[esi+12+8]
        movq      xmm3,[esi+12+16]
     ;   psrlw     xmm1,2
        punpcklwd xmm1,[the_zero]
        punpcklwd xmm2,[the_zero]
        punpcklwd xmm3,[the_zero]
        psrld     xmm1,1
        psrld     xmm2,1
      ;  psrld     xmm3,1

        andps     xmm0,[zero_hgst_dd]
        cvtdq2ps  xmm1,xmm1
        cvtdq2ps  xmm2,xmm2
        cvtdq2ps  xmm3,xmm3
        andps     xmm1,[zero_hgst_dd]
        andps     xmm2,[zero_hgst_dd]
        andps     xmm3,[zero_hgst_dd]

        movaps    [edi],xmm0
        movaps    [edi+16],xmm1
        movaps    [edi+32],xmm2
        movaps    [edi+48],xmm3

        add       edi,64
        add       esi,LIGHT_SIZE
        cmp       esi,lightsend
        jne       .do_aligned



        mov     esp,ebp
        pop     ebp
ret
;=======================================================
init_point_lights:
        mov       eax,-1000
        cvtsi2ss  xmm1,eax
        shufps    xmm1,xmm1,11000000b
        mov       esi,lights_aligned
        mov       edi,point_light_coords
        mov       ecx,3
      @@:
        movaps    xmm0,[esi]
        addps     xmm0,[f05x3]
        mulps     xmm0,xmm1
        addps     xmm0,xmm1
        movaps    [edi],xmm0
        add       esi,64
        add       edi,16
        loop      @b
ret
random:
;  in  - ecx - min
;        edx - max
;  out - eax - random number
         mov    bx,[rand_seed]
         add    bx,0x9248
         ror    bx,3
         mov    [rand_seed],bx

         mov    ax,dx
         sub    ax,cx
         mul    bx
         mov    ax,dx
         add    ax,cx
         cwde
ret
;=================================================================
do_color_buffer:         ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes    ; many lights using
.temp  equ word   [ebp-2]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,color_map
         fninit

         mov      dx,- TEX_Y / 2 ;-256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         mov      .temp,cx
         fild     .temp
         fidiv    [tex_x_div2];[i256]st = Nx - vector normal x cooficient
         fst      .nx
         fmul     st,st0
         mov      .temp,dx
         fild     .temp
         fidiv    [tex_y_div2];[i256]st = Ny - vector normal y coeficient
         fst      .ny
         fmul     st,st0
         faddp
         fld1
         fchs
         faddp
         fabs
         fsqrt
         fchs
         fstp     .nz              ; st - Nz - vect normal z coeficient
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         push     edi   ;env_map
         lea      esi,[lights+ebx]
         lea      edi,.nx
         call     dot_product
         pop      edi
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       .env_ok1  ;compare with dot_max
         ffree    st

        jmp       .update_counters
      .env_ok1:
         fcom    dword[dot_max]
         fstsw   ax
         sahf
         jb      .env_ok2     ; calc col
         ffree   st
         jmp     .update_counters
      .env_ok2:            ;calc col
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax         ; earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
  @@:
 .update_counters:                                  ; update and jump when neccesery
        add     ebx,LIGHT_SIZE
        cmp     bx,[all_lights_size]
        jl      .light    ; next_light
        mov     eax,dword .col_b
        stosd

        inc     cx
        cmp     cx,TEX_X / 2 ;256
        jne     .ie_hor

        inc     dx
        cmp     dx,TEX_X / 2 ;256
        jne     .ie_ver

    .env_done:
         mov     esp,ebp
         pop     ebp

ret

;============================================================
init_envmap2:         ; do env_map
;env_map 512 x 512 x 4 bytes
.temp  equ word   [ebp-2]
.nEy   equ word   [ebp-4]
.nEx   equ word   [ebp-6]
.col_r equ        [ebp-8]
.col_g equ        [ebp-9]
.col_b equ        [ebp-10]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,envmap
         fninit

         mov      dx,- TEX_Y / 2 ;256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         lea      esi,[lights+ebx]
         fld      dword[esi]     ; light vector x cooficient
         fimul    [tex_x_div2] ;[i256]
         mov      .temp,cx
         fisubr   .temp
         fistp    .nEx
         fld      dword[esi+4]   ; light vector y cooficient
         fimul    [tex_y_div2] ;[i256]
         mov      .temp,dx
         fisubr   .temp
         fistp    .nEy

         cmp      .nEx,- TEX_X / 2 ;256
         jl       .update_counters
         cmp      .nEy,- TEX_Y / 2 ;256
         jl       .update_counters
         cmp      .nEx,TEX_X / 2 ;256
         jg       .update_counters
         cmp      .nEy,TEX_Y / 2 ;256
         jg       .update_counters

         fild     .nEx
         fmul     st,st0
         fild     .nEy
         fmul     st,st0
         faddp
         fsqrt
         fisubr   [i256]
         fmul     [env_const]
         fidiv    [i256]   ; st - 'virtual' dot product

         fcom     dword[dot_max]
         fstsw    ax
         sahf
         jb       @f
         ffree    st
         fld1     ;[dot_max]
      @@:
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       @f
         ffree    st
         fldz     ;[dot_min]
      @@:
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax            ;    earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:                        ;  eax - ggbb00rr
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:                        ;  eax - bb0000gg
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
   @@:
   .update_counters:                     ; update and jump when neccesery
         add      ebx,LIGHT_SIZE
         cmp      bx,[all_lights_size]
         jl       .light    ; next_light
         mov      eax,dword .col_b
         or        eax,0xff000000
         stosd
     ;    dec      edi

         inc      cx
         cmp      cx,TEX_X / 2 ;256
         jne      .ie_hor

         inc      dx
         cmp      dx,TEX_Y / 2 ;256
         jne     .ie_ver

         mov     esp,ebp
         pop     ebp
ret

;=========================================================
  calc_one_col:
; procedure don't save registers !!!
; in -   st - dot_product
;        stack - other parameters
; out - eax - 0x00rrggbb
.dot_prd   equ dword[ebp+4]           ; dot product   - cos x  - not now
.min_col_r equ word[ebp+8]            ; minimum color - ambient
.min_col_g equ word[ebp+10]
.min_col_b equ word[ebp+12]
.max_col_r equ word[ebp+14]           ; maximum color - specular
.max_col_g equ word[ebp+16]
.max_col_b equ word[ebp+18]
.org_col_r equ word[ebp+20]           ; orginal color - diffuse
.org_col_g equ word[ebp+22]
.org_col_b equ word[ebp+24]
.n         equ word[ebp+26]           ; shines - not implemented
.temp      equ word[ebp-2]
.color_sum_r equ dword[ebp-6]
.color_sum_g equ dword[ebp-10]
.color_sum_b equ dword[ebp-14]
; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular
         mov     ebp,esp
         sub     esp,14

         mov      ax,.min_col_r
         add      ax,.max_col_r
         add      ax,.org_col_r
         cwde
         mov      .color_sum_r,eax

         mov      ax,.min_col_g
         add      ax,.max_col_g
         add      ax,.org_col_g
         cwde
         mov      .color_sum_g,eax

         mov      ax,.min_col_b
         add      ax,.max_col_b
         add      ax,.org_col_b
         cwde
         mov      .color_sum_b,eax


;         fld     .dot_prd
       ;  fild    .n
       ;  fxch    st1
       ;  fabs
       ;  fyl2x                     ;
       ;  f2xm1
       ;  fld1
       ;  faddp        ; st =  dot_product ^ n

         fld     st            ; copy dot pr
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
         cmp     .n,255            ; .n = 255 -> spot light
         jne     @f
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
      @@:
         fld     st            ; st0=st1=dot_pr^n, st2=dot_pr
         fimul   .max_col_b
         fild    .org_col_b
         fmul    st,st3
         faddp                 ; st0=first piece of col, st1=dot_pr^n..
         fiadd   .min_col_b
         fimul   .max_col_b
         fidiv   .color_sum_b
         fistp   .temp
         movzx   eax,.temp
         shl     eax,16

         fld     st
         fimul   .max_col_g
         fild    .org_col_g
         fmul    st,st3
         faddp
         fiadd   .min_col_g
         fimul   .max_col_g
         fidiv   .color_sum_g
         fistp   .temp
         mov     ax,.temp
         mov     ah,al
         shl     eax,8

         fimul   .max_col_r
         fild    .org_col_r
         fmulp   st2,st
         faddp
         fiadd   .min_col_r
         fimul   .max_col_r
         fidiv   .color_sum_r
         fistp   .temp
         mov     ax,.temp          ;eax -  0xbbgg00rr
     ;   mov     ah,al
         ror     eax,16
         xchg    al,ah             ; eax - 0x00rrggbb
         mov     esp,ebp
ret 24
